<template>
  <el-table
    v-loading="isDataLoading"
    border
    :data="transactions"
    max-height="510"
    class="rounded-md"
  >
    <template #empty>
      <utils-not-found />
    </template>
    <el-table-column
      prop="RequestedTimeForDisplay"
      :label="$t('date')"
      min-width="100"
      align="center"
    />
    <el-table-column
      prop="DisplayTransactionNo"
      :label="$t('transaction_no')"
      min-width="110"
      align="left"
      header-align="center"
    />
    <el-table-column
      prop="RequestedAmountForDisplay"
      :label="$t('requested_amount')"
      align="right"
      header-align="center"
    />
    <el-table-column :label="$t('approved_amount')" header-align="center">
      <template #default="scope">
        <span
          :class="`w-full flex ${
            scope.row.ApprovedAmountForDisplay === '--'
              ? 'justify-center'
              : 'justify-end'
          }`"
        >
          {{ scope.row.ApprovedAmountForDisplay }}
        </span>
      </template>
    </el-table-column>
    <el-table-column
      v-if="transactionType === 'DepositHistory'"
      :label="$t('deposit_time')"
      align="center"
      min-width="100"
      prop="DepositTime"
    />
    <el-table-column :label="$t('status')" align="center">
      <template #default="scope">
        <span :class="`fc-${scope.row.ColorClass}`">{{
          $t(String(scope.row.StatusForDisplay))
        }}</span>
      </template>
    </el-table-column>
    <el-table-column :label="$t('action')" align="center">
      <template #default="scope">
        <el-button
          v-if="scope.row.IsCancelable"
          :disabled="isProcessing"
          type="danger"
          plain
          round
          size="small"
          @click="cancelTransaction(scope.row)"
          >{{ $t("cancel") }}</el-button
        >
      </template>
    </el-table-column>
  </el-table>
  <div class="flex items-center m-2 time-notice-footer">
    <el-icon class="mx-1">
      <clock />
    </el-icon>
    <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
  </div>
</template>
<script lang="ts">
import { defineComponent } from "vue";
import { Clock } from "@element-plus/icons-vue";

export default defineComponent({
  name: "TransactionHistoryMainContent",
  components: {
    Clock,
  },
  setup() {
    const {
      transactions,
      transactionType,
      isDataLoading,
      cancelTransaction,
      isProcessing,
    } = useTransactionHistoryMainContent();
    return {
      transactions,
      transactionType,
      isDataLoading,
      cancelTransaction,
      isProcessing,
    };
  },
});
</script>
